part of '../flutterx_live_data.dart';

class LiveEvent<T> extends ObservableData<T> {
  void postSend(FutureOr<T> value) => _postSetData(value);

  void send(T value) => _setData(value);

  @override
  ObserverWrapper<T> observeForever(Observer<T> onChanged, {Dispatcher? dispatcher}) =>
      addObserverWrapper(ObserverWrapper<T>(onChanged, dispatcher));
}

class EventObserverWrapper<T> extends ObserverWrapper<T> {
  EventObserverWrapper(super.onChanged, super.dispatcher);

  @override
  void onAdded(ObservableData<T> data) {}
}

class MediatorLiveEvent<T> extends LiveEvent<T> with MediatorMixin<T> {}
